import es
import playerlib

class Ducklib(object):
    def __init__(self):
        self.functions = []
        self.ducked = []

        es.addons.registerTickListener(self.tickListener)
	
    def clear(self):
        self.ducked = []

    def register(self, event):
        if not callable(event):
            raise 'Ducklib: The event is not callable'
        self.functions.append(event)

    def unregister(self, event):
        try:
            self.functions.remove(event)
        except:
            pass

    def tickListener(self):
        for i in playerlib.getUseridList('#alive'):
            status = int(es.getplayerprop(i, 'CCSPlayer.baseclass.localdata.m_Local.m_bDucked')) 
            if status == 1 and i not in self.ducked:
                self.ducked.append(i)
                self.tell(i, True)
            elif status == 0 and i in self.ducked:
                self.ducked.remove(i)
                self.tell(i, False)

    def tell(self, userid, ducked):
        for i in self.functions:
            i(userid,ducked)						

ducklib = Ducklib()

def register(event):
    ducklib.register(event)

def unregister(event):
    ducklib.unregister(event)